//! Raw CAN frame definitions for the SPARK MAX.
#![allow(non_snake_case)]

use std::{fmt, marker, mem};

/* automatically generated by rust-bindgen */

#[repr(C)]
#[derive(Copy, Clone, Debug, Default, Eq, Hash, Ord, PartialEq, PartialOrd)]
pub struct __BindgenBitfieldUnit<Storage, Align>
where
    Storage: AsRef<[u8]> + AsMut<[u8]>,
{
    storage: Storage,
    align: [Align; 0],
}
impl<Storage, Align> __BindgenBitfieldUnit<Storage, Align>
where
    Storage: AsRef<[u8]> + AsMut<[u8]>,
{
    #[inline]
    pub fn new(storage: Storage) -> Self {
        Self { storage, align: [] }
    }
    #[inline]
    pub fn get_bit(&self, index: usize) -> bool {
        debug_assert!(index / 8 < self.storage.as_ref().len());
        let byte_index = index / 8;
        let byte = self.storage.as_ref()[byte_index];
        let bit_index = if cfg!(target_endian = "big") {
            7 - (index % 8)
        } else {
            index % 8
        };
        let mask = 1 << bit_index;
        byte & mask == mask
    }
    #[inline]
    pub fn set_bit(&mut self, index: usize, val: bool) {
        debug_assert!(index / 8 < self.storage.as_ref().len());
        let byte_index = index / 8;
        let byte = &mut self.storage.as_mut()[byte_index];
        let bit_index = if cfg!(target_endian = "big") {
            7 - (index % 8)
        } else {
            index % 8
        };
        let mask = 1 << bit_index;
        if val {
            *byte |= mask;
        } else {
            *byte &= !mask;
        }
    }
    #[inline]
    pub fn get(&self, bit_offset: usize, bit_width: u8) -> u64 {
        debug_assert!(bit_width <= 64);
        debug_assert!(bit_offset / 8 < self.storage.as_ref().len());
        debug_assert!((bit_offset + (bit_width as usize)) / 8 <= self.storage.as_ref().len());
        let mut val = 0;
        for i in 0..(bit_width as usize) {
            if self.get_bit(i + bit_offset) {
                let index = if cfg!(target_endian = "big") {
                    bit_width as usize - 1 - i
                } else {
                    i
                };
                val |= 1 << index;
            }
        }
        val
    }
    #[inline]
    pub fn set(&mut self, bit_offset: usize, bit_width: u8, val: u64) {
        debug_assert!(bit_width <= 64);
        debug_assert!(bit_offset / 8 < self.storage.as_ref().len());
        debug_assert!((bit_offset + (bit_width as usize)) / 8 <= self.storage.as_ref().len());
        for i in 0..(bit_width as usize) {
            let mask = 1 << i;
            let val_bit_is_set = val & mask == mask;
            let index = if cfg!(target_endian = "big") {
                bit_width as usize - 1 - i
            } else {
                i
            };
            self.set_bit(index + bit_offset, val_bit_is_set);
        }
    }
}
#[repr(C)]
#[derive(Clone, Copy, Hash, PartialEq, Eq)]
pub struct __BindgenUnionField<T>(marker::PhantomData<T>);
impl<T> __BindgenUnionField<T> {
    #[inline]
    pub fn new() -> Self {
        __BindgenUnionField(marker::PhantomData)
    }
    #[inline]
    pub unsafe fn as_ref(&self) -> &T {
        mem::transmute(self)
    }
    #[inline]
    pub unsafe fn as_mut(&mut self) -> &mut T {
        mem::transmute(self)
    }
}
impl<T> Default for __BindgenUnionField<T> {
    #[inline]
    fn default() -> Self {
        Self::new()
    }
}
impl<T> fmt::Debug for __BindgenUnionField<T> {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt.write_str("__BindgenUnionField")
    }
}

pub const CMD_API_SETPNT_SET: i32 = 1;
pub const CMD_API_DC_SET: i32 = 2;
pub const CMD_API_SPD_SET: i32 = 18;
pub const CMD_API_SMART_VEL_SET: i32 = 19;
pub const CMD_API_POS_SET: i32 = 50;
pub const CMD_API_VOLT_SET: i32 = 66;
pub const CMD_API_CURRENT_SET: i32 = 67;
pub const CMD_API_SMARTMOTION_SET: i32 = 82;
pub const CMD_API_STAT0: i32 = 96;
pub const CMD_API_STAT1: i32 = 97;
pub const CMD_API_STAT2: i32 = 98;
pub const CMD_API_CLEAR_FAULTS: i32 = 110;
pub const CMD_API_DRV_STAT: i32 = 106;
pub const CMD_API_BURN_FLASH: i32 = 114;
pub const CMD_API_SET_FOLLOWER: i32 = 115;
pub const CMD_API_FACTORY_DEFAULT: i32 = 116;
pub const CMD_API_FACTORY_RESET: i32 = 117;
pub const CMD_API_NACK: i32 = 128;
pub const CMD_API_ACK: i32 = 129;
pub const CMD_API_BROADCAST: i32 = 144;
pub const CMD_API_HEARTBEAT: i32 = 146;
pub const CMD_API_SYNC: i32 = 147;
pub const CMD_API_ID_QUERY: i32 = 148;
pub const CMD_API_ID_ASSIGN: i32 = 149;
pub const CMD_API_FIRMWARE: i32 = 152;
pub const CMD_API_ENUM: i32 = 153;
pub const CMD_API_SWDL_BOOTLOADER: i32 = 511;
pub const CMD_API_SWDL_DATA: i32 = 156;
pub const CMD_API_SWDL_CHKSUM: i32 = 157;
pub const CMD_API_SWDL_RETRANSMIT: i32 = 158;
pub const CMD_API_MECH_POS: i32 = 160;
pub const CMD_API_I_ACCUM: i32 = 162;
pub const CMD_API_PARAM_ACCESS: i32 = 768;

#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct frc_dataframe_setpoint_out_t {
    pub setpoint: f32,
    pub auxSetpoint: i16,
    // uint32_t pidSlot: 2; reserved: 6, 8
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 2usize], u8>,
}
#[test]
fn bindgen_test_layout_frc_dataframe_setpoint_out_t() {
    assert_eq!(
        mem::size_of::<frc_dataframe_setpoint_out_t>(),
        8usize,
        concat!("Size of: ", stringify!(frc_dataframe_setpoint_out_t))
    );
    assert_eq!(
        mem::align_of::<frc_dataframe_setpoint_out_t>(),
        1usize,
        concat!("Alignment of ", stringify!(frc_dataframe_setpoint_out_t))
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_setpoint_out_t>())).setpoint as *const _ as usize
        },
        0usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_setpoint_out_t),
            "::",
            stringify!(setpoint)
        )
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_setpoint_out_t>())).auxSetpoint as *const _
                as usize
        },
        4usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_setpoint_out_t),
            "::",
            stringify!(auxSetpoint)
        )
    );
}
impl frc_dataframe_setpoint_out_t {
    #[inline]
    pub fn pid_slot(&self) -> u32 {
        self._bitfield_1.get(0usize, 2u8) as u32
    }
    #[inline]
    pub fn set_pid_slot(&mut self, val: u32) {
        self._bitfield_1.set(0usize, 2u8, val as u64)
    }
    #[inline]
    pub fn new_bitfield_1(pid_slot: u32) -> __BindgenBitfieldUnit<[u8; 2usize], u8> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 2usize], u8> =
            Default::default();
        __bindgen_bitfield_unit.set(0usize, 2u8, pid_slot as u64);
        __bindgen_bitfield_unit
    }
}
#[repr(C, packed)]
#[derive(Debug, Copy, Clone, Default)]
pub struct frc_dataframe_statusConfig_out_t {
    pub updateRate: u16,
    pub statusSelect0: u8,
    pub statusSelect1: u8,
    pub statusSelect2: u8,
    pub statusSelect3: u8,
}
#[test]
fn bindgen_test_layout_frc_dataframe_statusConfig_out_t() {
    assert_eq!(
        mem::size_of::<frc_dataframe_statusConfig_out_t>(),
        6usize,
        concat!("Size of: ", stringify!(frc_dataframe_statusConfig_out_t))
    );
    assert_eq!(
        mem::align_of::<frc_dataframe_statusConfig_out_t>(),
        1usize,
        concat!(
            "Alignment of ",
            stringify!(frc_dataframe_statusConfig_out_t)
        )
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_statusConfig_out_t>())).updateRate as *const _
                as usize
        },
        0usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_statusConfig_out_t),
            "::",
            stringify!(updateRate)
        )
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_statusConfig_out_t>())).statusSelect0 as *const _
                as usize
        },
        2usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_statusConfig_out_t),
            "::",
            stringify!(statusSelect0)
        )
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_statusConfig_out_t>())).statusSelect1 as *const _
                as usize
        },
        3usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_statusConfig_out_t),
            "::",
            stringify!(statusSelect1)
        )
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_statusConfig_out_t>())).statusSelect2 as *const _
                as usize
        },
        4usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_statusConfig_out_t),
            "::",
            stringify!(statusSelect2)
        )
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_statusConfig_out_t>())).statusSelect3 as *const _
                as usize
        },
        5usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_statusConfig_out_t),
            "::",
            stringify!(statusSelect3)
        )
    );
}
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct frc_dataframe_setParam_out_t {
    pub parameter: u32,
    pub parameterType: u8,
}
#[test]
fn bindgen_test_layout_frc_dataframe_setParam_out_t() {
    assert_eq!(
        mem::size_of::<frc_dataframe_setParam_out_t>(),
        5usize,
        concat!("Size of: ", stringify!(frc_dataframe_setParam_out_t))
    );
    assert_eq!(
        mem::align_of::<frc_dataframe_setParam_out_t>(),
        1usize,
        concat!("Alignment of ", stringify!(frc_dataframe_setParam_out_t))
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_setParam_out_t>())).parameter as *const _ as usize
        },
        0usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_setParam_out_t),
            "::",
            stringify!(parameter)
        )
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_setParam_out_t>())).parameterType as *const _
                as usize
        },
        4usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_setParam_out_t),
            "::",
            stringify!(parameterType)
        )
    );
}
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct frc_dataframe_getParam_in_t {
    pub parameter0: u32,
    pub parameterType: u8,
    pub parameterResponse: u8,
}
#[test]
fn bindgen_test_layout_frc_dataframe_getParam_in_t() {
    assert_eq!(
        mem::size_of::<frc_dataframe_getParam_in_t>(),
        6usize,
        concat!("Size of: ", stringify!(frc_dataframe_getParam_in_t))
    );
    assert_eq!(
        mem::align_of::<frc_dataframe_getParam_in_t>(),
        1usize,
        concat!("Alignment of ", stringify!(frc_dataframe_getParam_in_t))
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_getParam_in_t>())).parameter0 as *const _ as usize
        },
        0usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_getParam_in_t),
            "::",
            stringify!(parameter0)
        )
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_getParam_in_t>())).parameterType as *const _
                as usize
        },
        4usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_getParam_in_t),
            "::",
            stringify!(parameterType)
        )
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_getParam_in_t>())).parameterResponse as *const _
                as usize
        },
        5usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_getParam_in_t),
            "::",
            stringify!(parameterResponse)
        )
    );
}
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct frc_dataframe_burnFlash_out_t {
    pub magicNum0: u8,
    pub magicNum1: u8,
}
#[test]
fn bindgen_test_layout_frc_dataframe_burnFlash_out_t() {
    assert_eq!(
        mem::size_of::<frc_dataframe_burnFlash_out_t>(),
        2usize,
        concat!("Size of: ", stringify!(frc_dataframe_burnFlash_out_t))
    );
    assert_eq!(
        mem::align_of::<frc_dataframe_burnFlash_out_t>(),
        1usize,
        concat!("Alignment of ", stringify!(frc_dataframe_burnFlash_out_t))
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_burnFlash_out_t>())).magicNum0 as *const _ as usize
        },
        0usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_burnFlash_out_t),
            "::",
            stringify!(magicNum0)
        )
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_burnFlash_out_t>())).magicNum1 as *const _ as usize
        },
        1usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_burnFlash_out_t),
            "::",
            stringify!(magicNum1)
        )
    );
}
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct frc_dataframe_follower_out_t {
    pub followerID: u32,
    pub followerCfg: u32,
}
#[test]
fn bindgen_test_layout_frc_dataframe_follower_out_t() {
    assert_eq!(
        mem::size_of::<frc_dataframe_follower_out_t>(),
        8usize,
        concat!("Size of: ", stringify!(frc_dataframe_follower_out_t))
    );
    assert_eq!(
        mem::align_of::<frc_dataframe_follower_out_t>(),
        1usize,
        concat!("Alignment of ", stringify!(frc_dataframe_follower_out_t))
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_follower_out_t>())).followerID as *const _ as usize
        },
        0usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_follower_out_t),
            "::",
            stringify!(followerID)
        )
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_follower_out_t>())).followerCfg as *const _
                as usize
        },
        4usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_follower_out_t),
            "::",
            stringify!(followerCfg)
        )
    );
}
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct frc_dataframe_firmware_in_t {
    pub firmwareMajor: u8,
    pub firmwareMinor: u8,
    pub firmwareBuild: u16,
    pub debugBuild: u8,
    pub hardwareRevision: u8,
}
#[test]
fn bindgen_test_layout_frc_dataframe_firmware_in_t() {
    assert_eq!(
        mem::size_of::<frc_dataframe_firmware_in_t>(),
        6usize,
        concat!("Size of: ", stringify!(frc_dataframe_firmware_in_t))
    );
    assert_eq!(
        mem::align_of::<frc_dataframe_firmware_in_t>(),
        1usize,
        concat!("Alignment of ", stringify!(frc_dataframe_firmware_in_t))
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_firmware_in_t>())).firmwareMajor as *const _
                as usize
        },
        0usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_firmware_in_t),
            "::",
            stringify!(firmwareMajor)
        )
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_firmware_in_t>())).firmwareMinor as *const _
                as usize
        },
        1usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_firmware_in_t),
            "::",
            stringify!(firmwareMinor)
        )
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_firmware_in_t>())).firmwareBuild as *const _
                as usize
        },
        2usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_firmware_in_t),
            "::",
            stringify!(firmwareBuild)
        )
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_firmware_in_t>())).debugBuild as *const _ as usize
        },
        4usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_firmware_in_t),
            "::",
            stringify!(debugBuild)
        )
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_firmware_in_t>())).hardwareRevision as *const _
                as usize
        },
        5usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_firmware_in_t),
            "::",
            stringify!(hardwareRevision)
        )
    );
}
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct frc_dataframe_status0_in_t {
    pub appliedOutput: i16,
    pub faults: u16,
    pub stickyFaults: u16,
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize], u8>,
}
#[test]
fn bindgen_test_layout_frc_dataframe_status0_in_t() {
    assert_eq!(
        mem::size_of::<frc_dataframe_status0_in_t>(),
        7usize,
        concat!("Size of: ", stringify!(frc_dataframe_status0_in_t))
    );
    assert_eq!(
        mem::align_of::<frc_dataframe_status0_in_t>(),
        1usize,
        concat!("Alignment of ", stringify!(frc_dataframe_status0_in_t))
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_status0_in_t>())).appliedOutput as *const _
                as usize
        },
        0usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_status0_in_t),
            "::",
            stringify!(appliedOutput)
        )
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_status0_in_t>())).faults as *const _ as usize
        },
        2usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_status0_in_t),
            "::",
            stringify!(faults)
        )
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_status0_in_t>())).stickyFaults as *const _ as usize
        },
        4usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_status0_in_t),
            "::",
            stringify!(stickyFaults)
        )
    );
}
impl frc_dataframe_status0_in_t {
    #[inline]
    pub fn sensorInv(&self) -> u8 {
        unsafe { mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
    }
    #[inline]
    pub fn setpointInv(&self) -> u8 {
        unsafe { mem::transmute(self._bitfield_1.get(1usize, 1u8) as u8) }
    }
    #[inline]
    pub fn idleMode(&self) -> u8 {
        unsafe { mem::transmute(self._bitfield_1.get(2usize, 2u8) as u8) }
    }
    #[inline]
    pub fn mtrType(&self) -> u8 {
        unsafe { mem::transmute(self._bitfield_1.get(4usize, 1u8) as u8) }
    }
    #[inline]
    pub fn is_follower(&self) -> u8 {
        unsafe { mem::transmute(self._bitfield_1.get(5usize, 1u8) as u8) }
    }
    #[inline]
    pub fn new_bitfield_1(
        sensorInv: u8,
        setpointInv: u8,
        idleMode: u8,
        mtrType: u8,
        is_follower: u8,
    ) -> __BindgenBitfieldUnit<[u8; 1usize], u8> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize], u8> =
            Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, sensorInv as u64);
        __bindgen_bitfield_unit.set(1usize, 1u8, setpointInv as u64);
        __bindgen_bitfield_unit.set(2usize, 2u8, idleMode as u64);
        __bindgen_bitfield_unit.set(4usize, 1u8, mtrType as u64);
        __bindgen_bitfield_unit.set(5usize, 1u8, is_follower as u64);
        __bindgen_bitfield_unit
    }
}

// TODO: investigate [2019-04-08T14:02:33Z ERROR bindgen::codegen::struct_layout] Calculated wrong layout for frc_dataframe_status1_in_t, too more 1 bytes
// I think bindgen can't deal with packed bitfields correctly
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct frc_dataframe_status1_in_t {
    pub sensorVel: f32,
    pub mtrTemp: u8,
    // uint16_t mtrVoltage : 12; uint16_t mtrCurrent : 12;
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 3usize], u8>,
}
#[test]
fn bindgen_test_layout_frc_dataframe_status1_in_t() {
    assert_eq!(
        mem::size_of::<frc_dataframe_status1_in_t>(),
        8usize,
        concat!("Size of: ", stringify!(frc_dataframe_status1_in_t))
    );
    assert_eq!(
        mem::align_of::<frc_dataframe_status1_in_t>(),
        1usize,
        concat!("Alignment of ", stringify!(frc_dataframe_status1_in_t))
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_status1_in_t>())).sensorVel as *const _ as usize
        },
        0usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_status1_in_t),
            "::",
            stringify!(sensorVel)
        )
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_status1_in_t>())).mtrTemp as *const _ as usize
        },
        4usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_status1_in_t),
            "::",
            stringify!(mtrTemp)
        )
    );
}
impl frc_dataframe_status1_in_t {
    #[inline]
    pub fn mtrVoltage(&self) -> u16 {
        unsafe { mem::transmute(self._bitfield_1.get(0usize, 12u8) as u16) }
    }
    #[inline]
    pub fn mtrCurrent(&self) -> u16 {
        unsafe { mem::transmute(self._bitfield_1.get(12usize, 12u8) as u16) }
    }
    #[inline]
    pub fn new_bitfield_1(
        mtrVoltage: u16,
        mtrCurrent: u16,
    ) -> __BindgenBitfieldUnit<[u8; 3usize], u8> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 3usize], u8> =
            Default::default();
        __bindgen_bitfield_unit.set(0usize, 12u8, mtrVoltage as u64);
        __bindgen_bitfield_unit.set(12usize, 12u8, mtrCurrent as u64);
        __bindgen_bitfield_unit
    }
}

#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct frc_dataframe_status2_in_t {
    pub sensorPos: f32,
    pub iAccum: f32,
}
#[test]
fn bindgen_test_layout_frc_dataframe_status2_in_t() {
    assert_eq!(
        mem::size_of::<frc_dataframe_status2_in_t>(),
        8usize,
        concat!("Size of: ", stringify!(frc_dataframe_status2_in_t))
    );
    assert_eq!(
        mem::align_of::<frc_dataframe_status2_in_t>(),
        1usize,
        concat!("Alignment of ", stringify!(frc_dataframe_status2_in_t))
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_status2_in_t>())).sensorPos as *const _ as usize
        },
        0usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_status2_in_t),
            "::",
            stringify!(sensorPos)
        )
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_status2_in_t>())).iAccum as *const _ as usize
        },
        4usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_status2_in_t),
            "::",
            stringify!(iAccum)
        )
    );
}
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct frc_dataframe_userStatus_in_t {
    pub userParam0ID: u16,
    pub userParam1ID: u16,
    pub userParam2ID: u16,
    pub userParam3ID: u16,
}
#[test]
fn bindgen_test_layout_frc_dataframe_userStatus_in_t() {
    assert_eq!(
        mem::size_of::<frc_dataframe_userStatus_in_t>(),
        8usize,
        concat!("Size of: ", stringify!(frc_dataframe_userStatus_in_t))
    );
    assert_eq!(
        mem::align_of::<frc_dataframe_userStatus_in_t>(),
        1usize,
        concat!("Alignment of ", stringify!(frc_dataframe_userStatus_in_t))
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_userStatus_in_t>())).userParam0ID as *const _
                as usize
        },
        0usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_userStatus_in_t),
            "::",
            stringify!(userParam0ID)
        )
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_userStatus_in_t>())).userParam1ID as *const _
                as usize
        },
        2usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_userStatus_in_t),
            "::",
            stringify!(userParam1ID)
        )
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_userStatus_in_t>())).userParam2ID as *const _
                as usize
        },
        4usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_userStatus_in_t),
            "::",
            stringify!(userParam2ID)
        )
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_userStatus_in_t>())).userParam3ID as *const _
                as usize
        },
        6usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_userStatus_in_t),
            "::",
            stringify!(userParam3ID)
        )
    );
}
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct frc_dataframe_drvStatus_in_t {
    pub DRVStat0: u16,
    pub DRVStat1: u16,
    pub faults: u16,
    pub stickyFaults: u16,
}
#[test]
fn bindgen_test_layout_frc_dataframe_drvStatus_in_t() {
    assert_eq!(
        mem::size_of::<frc_dataframe_drvStatus_in_t>(),
        8usize,
        concat!("Size of: ", stringify!(frc_dataframe_drvStatus_in_t))
    );
    assert_eq!(
        mem::align_of::<frc_dataframe_drvStatus_in_t>(),
        1usize,
        concat!("Alignment of ", stringify!(frc_dataframe_drvStatus_in_t))
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_drvStatus_in_t>())).DRVStat0 as *const _ as usize
        },
        0usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_drvStatus_in_t),
            "::",
            stringify!(DRVStat0)
        )
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_drvStatus_in_t>())).DRVStat1 as *const _ as usize
        },
        2usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_drvStatus_in_t),
            "::",
            stringify!(DRVStat1)
        )
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_drvStatus_in_t>())).faults as *const _ as usize
        },
        4usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_drvStatus_in_t),
            "::",
            stringify!(faults)
        )
    );
    assert_eq!(
        unsafe {
            &(*(::std::ptr::null::<frc_dataframe_drvStatus_in_t>())).stickyFaults as *const _
                as usize
        },
        6usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_drvStatus_in_t),
            "::",
            stringify!(stickyFaults)
        )
    );
}

#[repr(C)]
pub union frc_dataframe_t {
    pub setpoint_out: frc_dataframe_setpoint_out_t,
    pub statusConfig_out: frc_dataframe_statusConfig_out_t,
    pub setParam_out: frc_dataframe_setParam_out_t,
    pub burnFlash_out: frc_dataframe_burnFlash_out_t,
    pub follower_out: frc_dataframe_follower_out_t,
    pub firmware_in: frc_dataframe_firmware_in_t,
    pub status0_in: frc_dataframe_status0_in_t,
    pub status1_in: frc_dataframe_status1_in_t,
    pub status2_in: frc_dataframe_status2_in_t,
    pub userStatus_in: frc_dataframe_userStatus_in_t,
    pub drvStatus_in: frc_dataframe_drvStatus_in_t,
    pub getParam_in: frc_dataframe_getParam_in_t,
    pub data: [u8; 8],
}

#[test]
fn test_layout_frc_dataframe_t() {
    assert_eq!(
        mem::size_of::<frc_dataframe_t>(),
        8usize,
        "Size of: frc_dataframe_t"
    );
    assert_eq!(
        mem::align_of::<frc_dataframe_t>(),
        1usize,
        "Alignment of frc_dataframe_t"
    );
}

// bindgen autogenerated union below; dunno why it doesn't generate union items
// maybe because I didn't opt-in to deriving Copy?
/*
#[repr(C)]
pub struct frc_dataframe_t {
    pub setpointOut: __BindgenUnionField<frc_dataframe_setpoint_out_t>,
    pub statusConfigOut: __BindgenUnionField<frc_dataframe_statusConfig_out_t>,
    pub setParamOut: __BindgenUnionField<frc_dataframe_setParam_out_t>,
    pub burnFlashOut: __BindgenUnionField<frc_dataframe_burnFlash_out_t>,
    pub followerOut: __BindgenUnionField<frc_dataframe_follower_out_t>,
    pub firmwareIn: __BindgenUnionField<frc_dataframe_firmware_in_t>,
    pub status0In: __BindgenUnionField<frc_dataframe_status0_in_t>,
    pub status1In: __BindgenUnionField<frc_dataframe_status1_in_t>,
    pub status2In: __BindgenUnionField<frc_dataframe_status2_in_t>,
    pub userStatusIn: __BindgenUnionField<frc_dataframe_userStatus_in_t>,
    pub drvStatusIn: __BindgenUnionField<frc_dataframe_drvStatus_in_t>,
    pub getParamIn: __BindgenUnionField<frc_dataframe_getParam_in_t>,
    pub data: __BindgenUnionField<[u8; 8usize]>,
    pub bindgen_union_field: [u8; 8usize],
}
#[test]
fn bindgen_test_layout_frc_dataframe_t() {
    assert_eq!(
        mem::size_of::<frc_dataframe_t>(),
        8usize,
        concat!("Size of: ", stringify!(frc_dataframe_t))
    );
    assert_eq!(
        mem::align_of::<frc_dataframe_t>(),
        1usize,
        concat!("Alignment of ", stringify!(frc_dataframe_t))
    );
    assert_eq!(
        unsafe { &(*(::std::ptr::null::<frc_dataframe_t>())).setpointOut as *const _ as usize },
        0usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_t),
            "::",
            stringify!(setpointOut)
        )
    );
    assert_eq!(
        unsafe { &(*(::std::ptr::null::<frc_dataframe_t>())).statusConfigOut as *const _ as usize },
        0usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_t),
            "::",
            stringify!(statusConfigOut)
        )
    );
    assert_eq!(
        unsafe { &(*(::std::ptr::null::<frc_dataframe_t>())).setParamOut as *const _ as usize },
        0usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_t),
            "::",
            stringify!(setParamOut)
        )
    );
    assert_eq!(
        unsafe { &(*(::std::ptr::null::<frc_dataframe_t>())).burnFlashOut as *const _ as usize },
        0usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_t),
            "::",
            stringify!(burnFlashOut)
        )
    );
    assert_eq!(
        unsafe { &(*(::std::ptr::null::<frc_dataframe_t>())).followerOut as *const _ as usize },
        0usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_t),
            "::",
            stringify!(followerOut)
        )
    );
    assert_eq!(
        unsafe { &(*(::std::ptr::null::<frc_dataframe_t>())).firmwareIn as *const _ as usize },
        0usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_t),
            "::",
            stringify!(firmwareIn)
        )
    );
    assert_eq!(
        unsafe { &(*(::std::ptr::null::<frc_dataframe_t>())).status0In as *const _ as usize },
        0usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_t),
            "::",
            stringify!(status0In)
        )
    );
    assert_eq!(
        unsafe { &(*(::std::ptr::null::<frc_dataframe_t>())).status1In as *const _ as usize },
        0usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_t),
            "::",
            stringify!(status1In)
        )
    );
    assert_eq!(
        unsafe { &(*(::std::ptr::null::<frc_dataframe_t>())).status2In as *const _ as usize },
        0usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_t),
            "::",
            stringify!(status2In)
        )
    );
    assert_eq!(
        unsafe { &(*(::std::ptr::null::<frc_dataframe_t>())).userStatusIn as *const _ as usize },
        0usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_t),
            "::",
            stringify!(userStatusIn)
        )
    );
    assert_eq!(
        unsafe { &(*(::std::ptr::null::<frc_dataframe_t>())).drvStatusIn as *const _ as usize },
        0usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_t),
            "::",
            stringify!(drvStatusIn)
        )
    );
    assert_eq!(
        unsafe { &(*(::std::ptr::null::<frc_dataframe_t>())).getParamIn as *const _ as usize },
        0usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_t),
            "::",
            stringify!(getParamIn)
        )
    );
    assert_eq!(
        unsafe { &(*(::std::ptr::null::<frc_dataframe_t>())).data as *const _ as usize },
        0usize,
        concat!(
            "Offset of field: ",
            stringify!(frc_dataframe_t),
            "::",
            stringify!(data)
        )
    );
}
*/
